This is a live mirror of the Perl 5 development currently hosted at https://github.com/perl/perl5
Keep installing xsubpp in lib/ExtUtils,
[perl5.git] / installperl
index 1bc5a8e..55633c5 100755 (executable)
@@ -2,19 +2,23 @@
 
 BEGIN {
     require 5.004;
-    chdir '..' if !-d 'lib' and -d '..\lib';
+    chdir '..' if !-d 'lib' and -d '../lib';
     @INC = 'lib';
     $ENV{PERL5LIB} = 'lib';
 }
 
 use strict;
-use vars qw($Is_VMS $Is_W32 $Is_OS2 $Is_Cygwin $nonono $versiononly $depth);
+my ($Is_VMS, $Is_W32, $Is_OS2, $Is_Cygwin, $Is_Darwin,
+    $nonono, $dostrip, $versiononly, $silent, $verbose, $force,
+    $otherperls, $archname, $Is_NetWare, $nwinstall, $nopods);
+use vars qw /$depth/;
 
 BEGIN {
     $Is_VMS = $^O eq 'VMS';
     $Is_W32 = $^O eq 'MSWin32';
     $Is_OS2 = $^O eq 'os2';
     $Is_Cygwin = $^O eq 'cygwin';
+    $Is_Darwin = $^O eq 'darwin';
     if ($Is_VMS) { eval 'use VMS::Filespec;' }
 }
 
@@ -27,7 +31,16 @@ use File::Path ();
 use ExtUtils::Packlist;
 use Config;
 use subs qw(unlink link chmod);
-use vars qw($packlist);
+
+if ($Config{d_umask}) {
+    umask(022); # umasks like 077 aren't that useful for installations
+}
+
+$Is_NetWare = $Config{osname} eq 'NetWare';
+if ($Is_NetWare) {
+    $Is_W32 = 0;
+    $scr_ext = '.pl';
+}
 
 # override the ones in the rest of the script
 sub mkpath {
@@ -40,38 +53,94 @@ my $exe_ext = $Config{exe_ext};
 # Allow ``make install PERLNAME=something_besides_perl'':
 my $perl = defined($ENV{PERLNAME}) ? $ENV{PERLNAME} : 'perl';
 
-# This is the base used for versioned names, like "perl5.005".
+# This is the base used for versioned names, like "perl5.6.0".
 # It's separate because a common use of $PERLNAME is to install
 # perl as "perl5", if that's used as base for versioned files you
-# get "perl55.005".
+# get "perl55.6.0".
 my $perl_verbase = defined($ENV{PERLNAME_VERBASE})
                    ? $ENV{PERLNAME_VERBASE}
                    : $perl;
+my $dbg = '';
+my $ndbg = '';
+if ( $Is_VMS ) {
+    if ( defined $Config{usevmsdebug} ) {
+        if ( $Config{usevmsdebug} eq 'define' ) {
+            $dbg = 'dbg';
+            $ndbg = 'ndbg';
+        }
+    }
+}
 
+$otherperls = 1;
+my $destdir = '';
 while (@ARGV) {
     $nonono = 1 if $ARGV[0] eq '-n';
+    $dostrip = 1 if $ARGV[0] eq '-s';
     $versiononly = 1 if $ARGV[0] eq '-v';
+    $versiononly = 0 if $ARGV[0] eq '+v';
+    $silent = 1 if $ARGV[0] eq '-S';
+    $otherperls = 0 if $ARGV[0] eq '-o';
+    $force = 1 if $ARGV[0] eq '-f';
+    $verbose = 1 if $ARGV[0] eq '-V' || $ARGV [0] eq '-n';
+    $archname = 1 if $ARGV[0] eq '-A';
+    $nwinstall = 1 if $ARGV[0] eq '-netware';
+    $nopods = 1 if $ARGV[0] eq '-p';
+    $destdir = $1 if $ARGV[0] =~ /^-?-destdir=(.*)$/;
+    if ($ARGV[0] eq '-?' or $ARGV[0] =~ /^-?-h/) {
+       print <<"EOT";
+Usage $0: [switches]
+  -n       Don't actually run any commands; just print them.
+  -s        Run strip on installed binaries.
+  -v        Only install perl as a binary with the version number in the name.
+            (Override whatever config.sh says)
+  +v        Install perl as "perl" and as a binary with the version number in
+            the name.  (Override whatever config.sh says)
+  -S        Silent mode.
+  -f        Force installation (don't check if same version is there)
+  -o        Skip checking for other copies of perl in your PATH.
+  -V        Verbose mode.
+  -A        Also install perl with the architecture's name in the perl binary's
+            name.
+  -p        Don't install the pod files. [This will break use diagnostics;]
+  -netware  Install correctly on a Netware server.
+  -destdir  Prefix installation directories by this string.
+EOT
+       exit;
+    }
     shift;
 }
 
-my @scripts = qw(utils/c2ph utils/h2ph utils/h2xs utils/perlbug utils/perldoc
-               utils/pl2pm utils/splain utils/perlcc utils/dprofpp
-               x2p/s2p x2p/find2perl 
-               pod/pod2man pod/pod2html pod/pod2latex pod/pod2text
-               pod/pod2usage pod/podchecker pod/podselect);
+$versiononly = 1 if $Config{versiononly} && !defined $versiononly;
+my (@scripts, @tolink);
+open SCRIPTS, "utils.lst" or die "Can't open utils.lst: $!";
+while (<SCRIPTS>) {
+    next if /^#/;
+    s/\s*#\s*pod\s*=.*//; # install script regardless of pod location
+    next if /a2p/; # a2p is binary, to be installed separately
+    chomp;
+    if (/(\S*)\s*#\s*link\s*=\s*(\S*)/) {
+       push @scripts, $1;
+       push @tolink, [$1, $2];
+    } else {
+       push @scripts, $_;
+    }
+}
+close SCRIPTS;
 
 if ($scr_ext) { @scripts = map { "$_$scr_ext" } @scripts; }
 
-my @pods = (<pod/*.pod>);
+my @pods = $nopods ? () : (<pod/*.pod>);
 
 # Specify here any .pm files that are actually architecture-dependent.
 # (Those included with XS extensions under ext/ are automatically
 # added later.)
 # Now that the default privlib has the full perl version number included,
-# we no longer have to play the trick of sticking version-specific .pm 
+# we no longer have to play the trick of sticking version-specific .pm
 # files under the archlib directory.
 my %archpms = (
-    Config => 1, 
+    Config => 1,
+    lib => 1,
+    Cwd => 1,
 );
 
 if ($^O eq 'dos') {
@@ -79,97 +148,161 @@ if ($^O eq 'dos') {
     $archpms{config} = $archpms{filehand} = 1;
 }
 
-if ((-e "testcompile") && (defined($ENV{'COMPILE'})))
-{
-       push(@scripts, map("$_.exe", @scripts));
+if ((-e "testcompile") && (defined($ENV{'COMPILE'}))) {
+    push(@scripts, map("$_.exe", @scripts));
 }
 
 find(sub {
-       if ("$File::Find::dir/$_" =~ m{^ext/[^/]+/(.*)\.pm$}) {
-           (my $pm = $1) =~ s{^lib/}{};
-           $archpms{$pm} = 1;
-       }
-    }, 'ext');
+    if ("$File::Find::dir/$_" =~ m{^ext\b(.*)/([^/]+)\.pm$}) {
+       my($path, $modname) = ($1,$2);
+
+       # strip trailing component first
+       $path =~ s{/[^/]*$}{};
+
+       # strip optional "/lib";
+       $path =~ s{/lib\b}{};
+
+       # strip any leading /
+       $path =~ s{^/}{};
 
-my $ver = $];
-my $release = substr($ver,0,3);   # Not used presently.
-my $patchlevel = substr($ver,3,2);
+       # reconstitute canonical module name
+       $modname = "$path/$modname" if length $path;
+
+       # remember it
+       $archpms{$modname} = 1;
+    }
+}, 'ext');
+
+# print "[$_]\n" for sort keys %archpms;
+
+my $ver = $Config{version};
+my $release = substr($],0,3);   # Not used currently.
+my $patchlevel = substr($],3,2);
 die "Patchlevel of perl ($patchlevel)",
     "and patchlevel of config.sh ($Config{'PERL_VERSION'}) don't match\n"
        if $patchlevel != $Config{'PERL_VERSION'};
 
 # Fetch some frequently-used items from %Config
-my $installbin = $Config{installbin};
-my $installscript = $Config{installscript};
-my $installprivlib = $Config{installprivlib};
-my $installarchlib = $Config{installarchlib};
-my $installsitelib = $Config{installsitelib};
-my $installsitearch = $Config{installsitearch};
-my $installman1dir = $Config{installman1dir};
+my $installbin = "$destdir$Config{installbin}";
+my $installscript = "$destdir$Config{installscript}";
+my $installprivlib = "$destdir$Config{installprivlib}";
+my $installarchlib = "$destdir$Config{installarchlib}";
+my $installsitelib = "$destdir$Config{installsitelib}";
+my $installsitearch = "$destdir$Config{installsitearch}";
+my $installman1dir = "$destdir$Config{installman1dir}";
 my $man1ext = $Config{man1ext};
 my $libperl = $Config{libperl};
 # Shared library and dynamic loading suffixes.
 my $so = $Config{so};
 my $dlext = $Config{dlext};
 my $dlsrc = $Config{dlsrc};
+if ($^O eq 'os390') {
+    my $pwd;
+    chomp($pwd=`pwd`);
+    my $archlibexp = $Config{archlibexp};
+    my $usedl = $Config{usedl};
+    if ($usedl eq 'define') {
+       `./$^X -pibak -e 's{$pwd\/libperl.x}{$archlibexp/CORE/libperl.x}' lib/Config.pm`;
+    }
+}
+
+if ($nwinstall) {
+    # This is required only if we are installing on a NetWare server
+    $installscript = $Config{installnwscripts};
+    $installprivlib = $Config{installnwlib};
+    $installarchlib = $Config{installnwlib};
+    $installsitelib = $Config{installnwlib};
+}
 
 my $d_dosuid = $Config{d_dosuid};
 my $binexp = $Config{binexp};
 
 if ($Is_VMS) {  # Hang in there until File::Spec hits the big time
     foreach ( \$installbin,     \$installscript,  \$installprivlib,
-              \$installarchlib, \$installsitelib, \$installsitearch,
-              \$installman1dir ) {
-      $$_ = unixify($$_);  $$_ =~ s:/$::;
+             \$installarchlib, \$installsitelib, \$installsitearch,
+             \$installman1dir ) {
+       $$_ = unixify($$_);  $$_ =~ s:/$::;
     }
 }
 
 # Do some quick sanity checks.
 
-if ($d_dosuid && $>) { die "You must run as root to install suidperl\n"; }
+if (!$nonono && $d_dosuid && $>) { die "You must run as root to install suidperl\n"; }
 
    $installbin         || die "No installbin directory in config.sh\n";
--d $installbin         || mkpath($installbin, 1, 0777);
+-d $installbin         || mkpath($installbin, $verbose, 0777);
 -d $installbin         || $nonono || die "$installbin is not a directory\n";
 -w $installbin         || $nonono || die "$installbin is not writable by you\n"
        unless $installbin =~ m#^/afs/# || $nonono;
 
+if (!$Is_NetWare) {
+if (!$Is_VMS) {
 -x 'perl' . $exe_ext   || die "perl isn't executable!\n";
+}
+else {
+-x $ndbg . 'perl' . $exe_ext   || die "${ndbg}perl$exe_ext isn't executable!\n";
+    if ($dbg) {
+        -x $dbg . 'perl' . $exe_ext    || die "${dbg}perl$exe_ext isn't executable!\n";
+    }
+}
 -x 'suidperl' . $exe_ext|| die "suidperl isn't executable!\n" if $d_dosuid;
 
--x 't/TEST'            || $Is_W32
-                       || warn "WARNING: You've never run 'make test'!!!",
-                               "  (Installing anyway.)\n";
-
-if ($Is_W32 or $Is_Cygwin) {
-  my $perldll;
-
-if ($Is_Cygwin) {
-  $perldll = $libperl;
-  $perldll =~ s/(\..*)?$/.$dlext/;
-  if ($Config{useshrplib} eq 'true') {
-    # install ld2 and perlld as well
-    foreach ('ld2', 'perlld') {
-      safe_unlink("$installbin/$_");
-      copy("$_", "$installbin/$_");
-      chmod(0755, "$installbin/$_");
-    };
-  };
-} else {
-  $perldll = 'perl.' . $dlext;
-  $perldll = 'perl56.' . $dlext if $Config{'ccflags'} =~ /PERL_OBJECT/i;
-}
+-f 't/rantests'                || $Is_W32
+                       || warn "WARNING: You've never run 'make test' or",
+                               " some tests failed! (Installing anyway.)\n";
+} #if (!$Is_NetWare)
+
+if (($Is_W32 and ! $Is_NetWare) or $Is_Cygwin) {
+    my $perldll;
+
+    if ($Is_Cygwin) {
+       $perldll = $libperl;
+       my $v_e_r_s = $ver; $v_e_r_s =~ tr/./_/;
+       $perldll =~ s/(\..*)?$/$v_e_r_s.$dlext/;
+       $perldll =~ s/^lib/cyg/;
+       if ($Config{useshrplib} eq 'true') {
+           # install ld2 and perlld as well
+           foreach ('ld2', 'perlld') {
+               safe_unlink("$installbin/$_");
+               copy("$_", "$installbin/$_");
+               chmod(0755, "$installbin/$_");
+           };
+           open (LD2, ">$installbin/ld2");
+           print LD2 <<SHELL;
+#!/bin/sh
+#
+# ld wrapper, passes all args to perlld;
+#
+for trythis in $installbin/perl
+do
+  if [ -x \$trythis ]
+  then
+    \$trythis $installbin/perlld "\$\@"
+    exit \$?
+  fi
+done
+# hard luck!
+echo I see no perl executable around there
+echo perl is required to build dynamic libraries
+echo look if the path to perl in /bin/ld2 is correct
+exit 1
+SHELL
+           close LD2;
+           chmod(0755, "$installbin/ld2");
+       };
+    } else {
+       $perldll = 'perl59.' . $dlext;
+    }
 
-   if ($dlsrc ne "dl_none.xs") {
-      -f $perldll || die "No perl DLL built\n";
-   }
-# Install the DLL
+    if ($dlsrc ne "dl_none.xs") {
+       -f $perldll || die "No perl DLL built\n";
+    }
 
-   safe_unlink("$installbin/$perldll");
-   copy("$perldll", "$installbin/$perldll");
-   chmod(0755, "$installbin/$perldll");
-   
-} # if ($Is_W32 or $Is_Cygwin)
+    # Install the DLL
+    safe_unlink("$installbin/$perldll");
+    copy("$perldll", "$installbin/$perldll");
+    chmod(0755, "$installbin/$perldll");
+} # if (($Is_W32 and ! $Is_NetWare) or $Is_Cygwin)
 
 # This will be used to store the packlist
 my $packlist = ExtUtils::Packlist->new("$installarchlib/.packlist");
@@ -177,12 +310,23 @@ my $packlist = ExtUtils::Packlist->new("$installarchlib/.packlist");
 # First we install the version-numbered executables.
 
 if ($Is_VMS) {
-    safe_unlink("$installbin/$perl$exe_ext");
-    copy("perl$exe_ext", "$installbin/$perl$exe_ext");
-    chmod(0755, "$installbin/$perl$exe_ext");
-    safe_unlink("$installbin/${perl}shr$exe_ext");
-    copy("perlshr$exe_ext", "$installbin/${perl}shr$exe_ext");
-    chmod(0755, "$installbin/${perl}shr$exe_ext");
+    safe_unlink("$installbin/perl_setup.com");
+    copy("perl_setup.com", "$installbin/perl_setup.com");
+    chmod(0755, "$installbin/perl_setup.com");
+    safe_unlink("$installbin/$dbg$perl$exe_ext");
+    copy("$dbg$perl$exe_ext", "$installbin/$dbg$perl$exe_ext");
+    chmod(0755, "$installbin/$dbg$perl$exe_ext");
+    safe_unlink("$installbin/$dbg${perl}shr$exe_ext");
+    copy("$dbg${perl}shr$exe_ext", "$installbin/$dbg${perl}shr$exe_ext");
+    chmod(0755, "$installbin/$dbg${perl}shr$exe_ext");
+    if ($ndbg) {
+        safe_unlink("$installbin/$ndbg$perl$exe_ext");
+        copy("$ndbg$perl$exe_ext", "$installbin/$ndbg$perl$exe_ext");
+        chmod(0755, "$installbin/$ndbg$perl$exe_ext");
+       safe_unlink("$installbin/${dbg}a2p$exe_ext");
+       copy("x2p/${dbg}a2p$exe_ext", "$installbin/${dbg}a2p$exe_ext");
+       chmod(0755, "$installbin/${dbg}a2p$exe_ext");
+    }
 }
 elsif ($^O eq 'mpeix') {
     # MPE lacks hard links and requires that executables with special
@@ -195,10 +339,26 @@ elsif ($^O eq 'mpeix') {
     link($Config{perlpath}, "$installbin/perl$ver$exe_ext");
 }
 elsif ($^O ne 'dos') {
-    safe_unlink("$installbin/$perl_verbase$ver$exe_ext");
-    copy("perl$exe_ext", "$installbin/$perl_verbase$ver$exe_ext");
-    strip("$installbin/$perl_verbase$ver$exe_ext") if $^O =~ /^(rhapsody)$/;
-    chmod(0755, "$installbin/$perl_verbase$ver$exe_ext");
+    if (!$Is_NetWare) {
+       safe_unlink("$installbin/$perl_verbase$ver$exe_ext");
+       copy("perl$exe_ext", "$installbin/$perl_verbase$ver$exe_ext");
+       strip("$installbin/$perl_verbase$ver$exe_ext");
+       chmod(0755, "$installbin/$perl_verbase$ver$exe_ext");
+    }
+    else {
+       # If installing onto a NetWare server
+       if ($nwinstall) {
+           # Copy perl.nlm, echo.nlm, type.nlm, a2p.nlm & cgi2perl.nlm
+           mkpath($Config{installnwsystem}, 1, 0777);
+           copy("netware\\".$ENV{'MAKE_TYPE'}."\\perl.nlm", $Config{installnwsystem});
+           copy("netware\\testnlm\\echo\\echo.nlm", $Config{installnwsystem});
+           copy("netware\\testnlm\\type\\type.nlm", $Config{installnwsystem});
+           copy("x2p\\a2p.nlm", $Config{installnwsystem});
+           chmod(0755, "$Config{installnwsystem}\\perl.nlm");
+           mkpath($Config{installnwlcgi}, 1, 0777);
+           copy("lib\\auto\\cgi2perl\\cgi2perl.nlm", $Config{installnwlcgi});
+       }
+    } #if (!$Is_NetWare)
 }
 else {
     safe_unlink("$installbin/$perl.exe");
@@ -214,16 +374,16 @@ if ($d_dosuid) {
 # Install library files.
 
 my ($do_installarchlib, $do_installprivlib) = (0, 0);
-    
-mkpath($installprivlib, 1, 0777);
-mkpath($installarchlib, 1, 0777);
-mkpath($installsitelib, 1, 0777) if ($installsitelib);
-mkpath($installsitearch, 1, 0777) if ($installsitearch);
+
+mkpath($installprivlib, $verbose, 0777);
+mkpath($installarchlib, $verbose, 0777);
+mkpath($installsitelib, $verbose, 0777) if ($installsitelib);
+mkpath($installsitearch, $verbose, 0777) if ($installsitearch);
 
 if (chdir "lib") {
     $do_installarchlib = ! samepath($installarchlib, '.');
     $do_installprivlib = ! samepath($installprivlib, '.');
-    $do_installprivlib = 0 if $versiononly && !($installprivlib =~ m/\Q$]/);
+    $do_installprivlib = 0 if $versiononly && !($installprivlib =~ m/\Q$ver/);
 
     if ($do_installarchlib || $do_installprivlib) {
        find(\&installlib, '.');
@@ -235,12 +395,12 @@ else {
 }
 
 # Install header files and libraries.
-mkpath("$installarchlib/CORE", 1, 0777);
+mkpath("$installarchlib/CORE", $verbose, 0777);
 my @corefiles;
 if ($Is_VMS) {  # We did core file selection during build
-    my $coredir = "lib/$Config{'arch'}/$]";
+    my $coredir = "lib/$Config{archname}/$ver/CORE";
     $coredir =~ tr/./_/;
-    @corefiles = <$coredir/*.*>;
+    map { s|^$coredir/||i; } @corefiles = <$coredir/*.*>;
 }
 else {
     # [als] hard-coded 'libperl' name... not good!
@@ -249,9 +409,9 @@ else {
     # AIX needs perl.exp installed as well.
     push(@corefiles,'perl.exp') if $^O eq 'aix';
     if ($^O eq 'mpeix') {
-        # MPE needs mpeixish.h installed as well.
-        mkpath("$installarchlib/CORE/mpeix", 1, 0777);
-        push(@corefiles,'mpeix/mpeixish.h');
+       # MPE needs mpeixish.h installed as well.
+       mkpath("$installarchlib/CORE/mpeix", $verbose, 0777);
+       push(@corefiles,'mpeix/mpeixish.h');
     }
     # If they have built sperl.o...
     push(@corefiles,'sperl.o') if -f 'sperl.o';
@@ -260,9 +420,9 @@ foreach my $file (@corefiles) {
     # HP-UX (at least) needs to maintain execute permissions
     # on dynamically-loadable libraries. So we do it for all.
     if (copy_if_diff($file,"$installarchlib/CORE/$file")) {
-       if ($file =~ /\.(so|\Q$dlext\E)$/) {
+       if ($file =~ /\.(\Q$so\E|\Q$dlext\E)$/) {
+           strip("-S", "$installarchlib/CORE/$file") if $^O =~ /^(rhapsody|darwin)$/;
            chmod(0555, "$installarchlib/CORE/$file");
-           strip("-S", "$installarchlib/CORE/$file") if $^O =~ /^(rhapsody)$/;
        } else {
            chmod(0444, "$installarchlib/CORE/$file");
        }
@@ -272,27 +432,49 @@ foreach my $file (@corefiles) {
 # Install main perl executables
 # Make links to ordinary names if installbin directory isn't current directory.
 
-if (! $versiononly && ! samepath($installbin, '.') && ($^O ne 'dos') && ! $Is_VMS) {
+if (! $versiononly && ! samepath($installbin, '.') && ($^O ne 'dos') && ! $Is_VMS && ! $Is_NetWare) {
     safe_unlink("$installbin/$perl$exe_ext", "$installbin/suid$perl$exe_ext");
     if ($^O eq 'mpeix') {
        # MPE doesn't support hard links, so use a symlink.
        # We don't want another cloned copy.
-        symlink($Config{perlpath}, "$installbin/perl$exe_ext");
+       symlink($Config{perlpath}, "$installbin/perl$exe_ext");
+    } elsif ($^O eq 'vos') {
+       # VOS doesn't support hard links, so use a symlink.
+       symlink("$installbin/$perl_verbase$ver$exe_ext",
+               "$installbin/$perl$exe_ext");
     } else {
        link("$installbin/$perl_verbase$ver$exe_ext",
                "$installbin/$perl$exe_ext");
     }
     link("$installbin/s$perl_verbase$ver$exe_ext",
-           "$installbin/suid$perl$exe_ext") 
+           "$installbin/suid$perl$exe_ext")
       if $d_dosuid;
 }
 
+# For development purposes it can be very useful to have multiple perls
+# build for different "architectures" (eg threading or not) simultaneously.
+if ($archname && ! samepath($installbin, '.') && ($^O ne 'dos') && ! $Is_VMS) {
+    my $archperl = "$perl_verbase$ver-$Config{archname}$exe_ext";
+    safe_unlink("$installbin/$archperl");
+    if ($^O eq 'mpeix') {
+       # MPE doesn't support hard links, so use a symlink.
+       # We don't want another cloned copy.
+       symlink($Config{perlpath}, "$installbin/$archperl");
+    } elsif ($^O eq 'vos') {
+       # VOS doesn't support hard links, so use a symlink.
+       symlink("$installbin/$perl_verbase$ver$exe_ext",
+               "$installbin/$archperl");
+    } else {
+       link("$installbin/$perl_verbase$ver$exe_ext", "$installbin/$archperl");
+    }
+}
+
 # Offer to install perl in a "standard" location
 
 my $mainperl_is_instperl = 0;
 
-if ($Config{installusrbinperl} eq 'define' &&
-    !$versiononly && !$nonono && !$Is_W32 && !$Is_VMS && -t STDIN && -t STDERR
+if ($Config{installusrbinperl} && $Config{installusrbinperl} eq 'define' &&
+    !$versiononly && !$nonono && !$Is_W32 && !$Is_NetWare && !$Is_VMS && -t STDIN && -t STDERR
        && -w $mainperldir && ! samepath($mainperldir, $installbin)) {
     my($usrbinperl)    = "$mainperldir/$perl$exe_ext";
     my($instperl)      = "$installbin/$perl$exe_ext";
@@ -310,11 +492,7 @@ if ($Config{installusrbinperl} eq 'define' &&
              (-l $usrbinperl) &&
              ((readlink $usrbinperl) eq $expinstperl));
     }
-    if ((! $mainperl_is_instperl) &&
-       (yn("Many scripts expect perl to be installed as $usrbinperl.\n" . 
-            "Do you wish to have $usrbinperl be the same as\n" .
-            "$expinstperl? [y] ")))
-    {
+    if (! $mainperl_is_instperl) {
        unlink($usrbinperl);
        ( $Config{'d_link'} eq 'define' &&
          eval { CORE::link $instperl, $usrbinperl } )  ||
@@ -326,11 +504,15 @@ if ($Config{installusrbinperl} eq 'define' &&
 }
 
 # Make links to ordinary names if installbin directory isn't current directory.
-
-if (!$versiononly && ! samepath($installbin, 'x2p')) {
-    safe_unlink("$installbin/a2p$exe_ext");
-    copy("x2p/a2p$exe_ext", "$installbin/a2p$exe_ext");
-    chmod(0755, "$installbin/a2p$exe_ext");
+if (!$Is_NetWare && $dbg eq '') {
+    if (! samepath($installbin, 'x2p')) {
+       my $base = 'a2p';
+       $base .= $ver if $versiononly;
+       safe_unlink("$installbin/$base$exe_ext");
+       copy("x2p/a2p$exe_ext", "$installbin/$base$exe_ext");
+       strip("$installbin/$base$exe_ext");
+       chmod(0755, "$installbin/$base$exe_ext");
+    }
 }
 
 # cppstdin is just a script, but it is architecture-dependent, so
@@ -343,35 +525,59 @@ if (! $versiononly && (-f 'cppstdin') && (! samepath($installbin, '.'))) {
     chmod(0755, "$installbin/cppstdin");
 }
 
-# Install scripts.
+sub script_alias {
+    my ($installscript, $orig, $alias, $scr_ext) = @_;
 
-mkpath($installscript, 1, 0777);
+    safe_unlink("$installscript/$alias$scr_ext");
+    if ($^O eq 'dos' or $Is_VMS or $^O eq 'transit') {
+       copy("$installscript/$orig$scr_ext",
+            "$installscript/$alias$scr_ext");
+    } elsif ($^O eq 'vos') {
+       symlink("$installscript/$orig$scr_ext",
+               "$installscript/$alias$scr_ext");
+    } else {
+       link("$installscript/$orig$scr_ext",
+            "$installscript/$alias$scr_ext");
+    }
+}
 
-if (! $versiononly) {
+# Install scripts.
+mkpath($installscript, $verbose, 0777);
+if ($versiononly) {
     for (@scripts) {
        (my $base = $_) =~ s#.*/##;
-       copy($_, "$installscript/$base");
+       $base .= $ver;
+       copy($_,    "$installscript/$base");
        chmod(0755, "$installscript/$base");
     }
-}
 
-# pstruct should be a link to c2ph
+    for (@tolink) {
+       my ($from, $to) = map { "$_$ver" } @$_;
+       (my $frbase = $from) =~ s#.*/##;
+       (my $tobase = $to) =~ s#.*/##;
+       script_alias($installscript, $frbase, $tobase, $scr_ext);
+    }
+} else {
+    for (@scripts) {
+       (my $base = $_) =~ s#.*/##;
+       copy($_, "$installscript/$base");
+       chmod(0755, "$installscript/$base");
+    }
 
-if (! $versiononly) {
-    safe_unlink("$installscript/pstruct$scr_ext");
-    if ($^O eq 'dos' or $Is_VMS) {
-        copy("$installscript/c2ph$scr_ext", "$installscript/pstruct$scr_ext"); 
-    } else {
-        link("$installscript/c2ph$scr_ext", "$installscript/pstruct$scr_ext");
+    for (@tolink) {
+       my ($from, $to) = @$_;
+       (my $frbase = $from) =~ s#.*/##;
+       (my $tobase = $to) =~ s#.*/##;
+       script_alias($installscript, $frbase, $tobase, $scr_ext);
     }
 }
 
 # Install pod pages.  Where? I guess in $installprivlib/pod
 # ($installprivlib/pods for cygwin).
 
-my $pod = $Is_Cygwin ? 'pods' : 'pod';
-unless ( $versiononly && !($installprivlib =~ m/\Q$]/)) {
-    mkpath("${installprivlib}/$pod", 1, 0777);
+my $pod = ($Is_Cygwin || $Is_Darwin) ? 'pods' : 'pod';
+if ( !$versiononly || ($installprivlib =~ m/\Q$ver/)) {
+    mkpath("${installprivlib}/$pod", $verbose, 0777);
 
     # If Perl 5.003's perldiag.pod is there, rename it.
     if (open POD, "${installprivlib}/$pod/perldiag.pod") {
@@ -390,7 +596,7 @@ unless ( $versiononly && !($installprivlib =~ m/\Q$]/)) {
 
     for (@pods) {
        # $_ is a name like  pod/perl.pod
-        (my $base = $_) =~ s#.*/##;
+       (my $base = $_) =~ s#.*/##;
        copy_if_diff($_, "${installprivlib}/$pod/${base}");
     }
 
@@ -402,17 +608,17 @@ unless ( $versiononly && !($installprivlib =~ m/\Q$]/)) {
 # Also skip $mainperl if the user opted to have it be a link to the
 # installed perl.
 
-if (!$versiononly) {
-       my ($path, @path);
-    my $dirsep = ($Is_OS2 || $Is_W32) ? ';' : ':' ;
+if (!$versiononly && $otherperls) {
+    my ($path, @path);
+    my $dirsep = ($Is_OS2 || $Is_W32 || $Is_NetWare) ? ';' : ':' ;
     ($path = $ENV{"PATH"}) =~ s:\\:/:g ;
     @path = split(/$dirsep/, $path);
     if ($Is_VMS) {
-        my $i = 0;
-        while (exists $ENV{'DCL$PATH' . $i}) {
-            my $dir = unixpath($ENV{'DCL$PATH' . $i});  $dir =~ s-/$--;
-            push(@path,$dir);
-        }
+       my $i = 0;
+       while (exists $ENV{'DCL$PATH' . $i}) {
+           my $dir = unixpath($ENV{'DCL$PATH' . $i});  $dir =~ s-/$--;
+           push(@path,$dir);
+       }
     }
     my @otherperls;
     my %otherperls;
@@ -422,24 +628,24 @@ if (!$versiononly) {
        # to $mainperldir (like SunOS)
        next if samepath($_, $binexp);
        next if ($mainperl_is_instperl && samepath($_, $mainperldir));
-        my $otherperl = "$_/$perl$exe_ext";
+       my $otherperl = "$_/$perl$exe_ext";
        next if $otherperls{$otherperl}++;
        push(@otherperls, $otherperl)
            if (-x $otherperl && ! -d $otherperl);
     }
     if (@otherperls) {
-       print STDERR "\nWarning: $perl appears in your path in the following " .
+       warn "\nWarning: $perl appears in your path in the following " .
            "locations beyond where\nwe just installed it:\n";
        for (@otherperls) {
-           print STDERR "    ", $_, "\n";
+           warn "    ", $_, "\n";
        }
-       print STDERR "\n";
+       warn "\n";
     }
 
 }
 
 $packlist->write() unless $nonono;
-print "  Installation complete\n";
+print "  Installation complete\n" if $verbose;
 
 exit 0;
 
@@ -449,7 +655,7 @@ sub yn {
     my($prompt) = @_;
     my($answer);
     my($default) = $prompt =~ m/\[([yn])\]\s*$/i;
-    print $prompt;
+    print STDERR $prompt;
     chop($answer = <STDIN>);
     $answer = $default if $answer =~ m/^\s*$/;
     ($answer =~ m/^[yY]/);
@@ -463,9 +669,9 @@ sub unlink {
 
     foreach my $name (@names) {
        next unless -e $name;
-       chmod 0777, $name if ($Is_OS2 || $Is_W32 || $Is_Cygwin);
-       print "  unlink $name\n";
-       ( CORE::unlink($name) and ++$cnt 
+       chmod 0777, $name if ($Is_OS2 || $Is_W32 || $Is_Cygwin || $Is_NetWare);
+       print "  unlink $name\n" if $verbose;
+       ( CORE::unlink($name) and ++$cnt
          or warn "Couldn't unlink $name: $!\n" ) unless $nonono;
     }
     return $cnt;
@@ -476,12 +682,12 @@ sub safe_unlink {
     my @names = @_;
     foreach my $name (@names) {
        next unless -e $name;
-       chmod 0777, $name if ($Is_OS2 || $Is_W32);
-       print "  unlink $name\n";
+       chmod 0777, $name if ($Is_OS2 || $Is_W32 || $Is_NetWare);
+       print "  unlink $name\n" if $verbose;
        next if CORE::unlink($name);
        warn "Couldn't unlink $name: $!\n";
        if ($! =~ /busy/i) {
-           print "  mv $name $name.old\n";
+           print "  mv $name $name.old\n" if $verbose;
            safe_rename($name, "$name.old")
                or warn "Couldn't rename $name: $!\n";
        }
@@ -495,7 +701,7 @@ sub safe_rename {
        for ($i = 1; $i < 50; $i++) {
            last if rename($to, "$to.$i");
        }
-       warn("Cannot rename to `$to.$i': $!"), return 0 
+       warn("Cannot rename to `$to.$i': $!"), return 0
           if $i >= 50; # Give up!
     }
     link($from,$to) || return 0;
@@ -506,23 +712,32 @@ sub link {
     my($from,$to) = @_;
     my($success) = 0;
 
-    print "  ln $from $to\n";
+    my $xfrom = $from;
+    $xfrom =~ s/^\Q$destdir\E// if $destdir;
+    my $xto = $to;
+    $xto =~ s/^\Q$destdir\E// if $destdir;
+    print $verbose ? "  ln $xfrom $xto\n" : "  $xto\n" unless $silent;
     eval {
        CORE::link($from, $to)
            ? $success++
            : ($from =~ m#^/afs/# || $to =~ m#^/afs/#)
              ? die "AFS"  # okay inside eval {}
-             : warn "Couldn't link $from to $to: $!\n"
+             : die "Couldn't link $from to $to: $!\n"
          unless $nonono;
-        $packlist->{$to} = { from => $from, type => 'link' };
+       $packlist->{$xto} = { from => $xfrom, type => 'link' };
     };
     if ($@) {
-       print "  creating new version of $to\n" if $Is_VMS and -e $to;
-       File::Copy::copy($from, $to)
-           ? $success++
-           : warn "Couldn't copy $from to $to: $!\n"
-         unless $nonono;
-        $packlist->{$to} = { type => 'file' };
+       warn "Replacing link() with File::Copy::copy(): $@";
+       print $verbose ? "  cp $from $xto\n" : "  $xto\n" unless $silent;
+       print "  creating new version of $xto\n"
+                if $Is_VMS and -e $to and !$silent;
+       unless ($nonono or File::Copy::copy($from, $to) and ++$success) {
+           # Might have been that F::C::c can't overwrite the target
+           warn "Couldn't copy $from to $to: $!\n"
+               unless -f $to and (chmod(0666, $to), unlink $to)
+                       and File::Copy::copy($from, $to) and ++$success;
+       }
+       $packlist->{$xto} = { type => 'file' };
     }
     $success;
 }
@@ -531,7 +746,7 @@ sub chmod {
     my($mode,$name) = @_;
 
     return if ($^O eq 'dos');
-    printf "  chmod %o %s\n", $mode, $name;
+    printf "  chmod %o %s\n", $mode, $name if $verbose;
     CORE::chmod($mode,$name)
        || warn sprintf("Couldn't chmod %o %s: $!\n", $mode, $name)
       unless $nonono;
@@ -540,18 +755,23 @@ sub chmod {
 sub copy {
     my($from,$to) = @_;
 
-    print "  cp $from $to\n";
-    print "  creating new version of $to\n" if $Is_VMS and -e $to;
-    File::Copy::copy($from, $to)
-       || warn "Couldn't copy $from to $to: $!\n"
-      unless $nonono;
-    $packlist->{$to} = { type => 'file' };
+    my $xto = $to;
+    $xto =~ s/^\Q$destdir\E// if $destdir;
+    print $verbose ? "  cp $from $xto\n" : "  $xto\n" unless $silent;
+    print "  creating new version of $xto\n" if $Is_VMS and -e $to and !$silent;
+    unless ($nonono or File::Copy::copy($from, $to)) {
+       # Might have been that F::C::c can't overwrite the target
+       warn "Couldn't copy $from to $to: $!\n"
+           unless -f $to and (chmod(0666, $to), unlink $to)
+                  and File::Copy::copy($from, $to);
+    }
+    $packlist->{$xto} = { type => 'file' };
 }
 
 sub samepath {
     my($p1, $p2) = @_;
 
-    return (lc($p1) eq lc($p2)) if $Is_W32;
+    return (lc($p1) eq lc($p2)) if ($Is_W32 || $Is_NetWare);
 
     if ($p1 ne $p2) {
        my($dev1, $ino1, $dev2, $ino2);
@@ -571,24 +791,33 @@ sub installlib {
 
     my $name = $_;
 
-    # Ignore RCS and CVS directories.
-    if (($name eq 'CVS' or $name eq 'RCS') and -d $name) {
+    # Ignore version control directories.
+    if ($name =~ /^(?:CVS|RCS|SCCS|\.svn)\z/ and -d $name) {
        $File::Find::prune = 1;
        return;
     }
-    
+
     # ignore patch backups, RCS files, emacs backup & temp files and the
-    # .exists files.
-    return if $name =~ m{\.orig$|~$|^#.+#$|,v$|^\.exists};
+    # .exists files, .PL files, and test files.
+    return if $name =~ m{\.orig$|\.rej$|~$|^#.+#$|,v$|^\.exists|\.PL$|\.plc$|\.t$|^test\.pl$} ||
+             $dir  =~ m{/t(?:/|$)};
+    # ignore the cpan script in lib/CPAN/bin, the instmodsh and xsubpp
+    # scripts in lib/ExtUtils, and the prove script in lib/Test/Harness
+    # (they're installed later with other utils)
+    return if $name =~ /^(?:cpan|instmodsh|prove)\z/;
+    # ignore the Makefiles
+    return if $name =~ /^makefile$/i;
+    # ignore the test extensions
+    return if $dir =~ m{ext/XS/(?:APItest|Typemap)/};
 
     $name = "$dir/$name" if $dir ne '';
 
     my $installlib = $installprivlib;
     if ($dir =~ /^auto/ ||
          ($name =~ /^(.*)\.(?:pm|pod)$/ && $archpms{$1}) ||
-         ($name =~ /^(.*)\.(?:h|lib)$/i && $Is_W32)
+         ($name =~ /^(.*)\.(?:h|lib)$/i && ($Is_W32 || $Is_NetWare))
        ) {
-        $installlib = $installarchlib;
+       $installlib = $installarchlib;
        return unless $do_installarchlib;
     } else {
        return unless $do_installprivlib;
@@ -603,15 +832,36 @@ sub installlib {
            #This might not work because $archname might have changed.
            unlink("$installarchlib/$name");
        }
-        $packlist->{"$installlib/$name"} = { type => 'file' };
-       if (compare($_, "$installlib/$name") || $nonono) {
+       my $xname = "$installlib/$name";
+       $xname =~ s/^\Q$destdir\E// if $destdir;
+       $packlist->{$xname} = { type => 'file' };
+       if ($force || compare($_, "$installlib/$name") || $nonono) {
            unlink("$installlib/$name");
-           mkpath("$installlib/$dir", 1, 0777);
+           mkpath("$installlib/$dir", $verbose, 0777);
            # HP-UX (at least) needs to maintain execute permissions
            # on dynamically-loaded libraries.
-           copy_if_diff($_, "$installlib/$name")
-               and chmod($name =~ /\.(so|$dlext)$/o ? 0555 : 0444,
-                          "$installlib/$name");
+           if ($Is_NetWare && !$nwinstall) {
+               # Don't copy .nlp,.nlm files, doesn't make sense on Windows and also
+               # if copied will give problems when building new extensions.
+               # Has to be copied if we are installing on a NetWare server and hence
+               # the check !$nwinstall
+               if (!(/\.(?:nlp|nlm|bs)$/)) {
+                   copy_if_diff($_, "$installlib/$name")
+                       and chmod($name =~ /\.(so|$dlext)$/o ? 0555 : 0444,
+                                 "$installlib/$name");
+               }
+          } else {
+               if (copy_if_diff($_, "$installlib/$name")) {
+                   if ($name =~ /\.(so|$dlext)$/o) {
+                       strip("-S", "$installlib/$name") if $^O =~ /^(rhapsody|darwin)$/;
+                       chmod(0555, "$installlib/$name");
+                   } else {
+                       strip("-S", "$installlib/$name")
+                           if ($name =~ /\.a$/o and $^O =~ /^(rhapsody|darwin)$/);
+                       chmod(0444, "$installlib/$name");
+                   }
+               }
+           } #if ($Is_NetWare)
        }
     }
 }
@@ -629,13 +879,29 @@ sub installlib {
 sub copy_if_diff {
     my($from,$to)=@_;
     return 1 if (($^O eq 'VMS') && (-d $from));
-    -f $from || die "$0: $from not found";
-    $packlist->{$to} = { type => 'file' };
-    if (compare($from, $to) || $nonono) {
+    my $xto = $to;
+    $xto =~ s/^\Q$destdir\E// if $destdir;
+    my $perlpodbadsymlink;
+    if ($from =~ m!^pod/perl[\w-]+\.pod$! &&
+       -l $from &&
+       ! -e $from) {
+       # Some Linux implementations have problems traversing over
+       # multiple symlinks (when going over NFS?) and fail to read
+       # the symlink target.  Combine this with the fact that some
+       # of the pod files (the perl$OS.pod) are symlinks (to ../README.$OS),
+       # and you end up with those pods not getting installed.
+       $perlpodbadsymlink = 1;
+    }
+    -f $from || $perlpodbadsymlink || warn "$0: $from not found";
+    $packlist->{$xto} = { type => 'file' };
+    if ($force || compare($from, $to) || $nonono) {
        safe_unlink($to);   # In case we don't have write permissions.
-        if ($nonono) {
-            $from = $depth . "/" . $from if $depth;
-        }
+       if ($nonono) {
+           $from = $depth . "/" . $from if $depth;
+       }
+       if ($perlpodbadsymlink && $from =~ m!^pod/perl(.+)\.pod$!) {
+           $from = "README.$1";
+       }
        copy($from, $to);
        # Restore timestamps if it's a .a library or for OS/2.
        if (!$nonono && ($Is_OS2 || $to =~ /\.a$/)) {
@@ -650,18 +916,23 @@ sub strip
 {
     my(@args) = @_;
 
+    return unless $dostrip;
+
     my @opts;
     while (@args && $args[0] =~ /^(-\w+)$/) {
-        push @opts, shift @args;
+       push @opts, shift @args;
     }
 
     foreach my $file (@args) {
-        if (-f $file) {
-            print "  strip $file\n";
-            system("strip", @opts, $file);
-        } else {
-            print "# file '$file' skipped\n";
-        }
+       if (-f $file) {
+           if ($verbose) {
+               print "  strip " . join(' ', @opts);
+               print " " if (@opts);
+               print "$file\n";
+           }
+           system("strip", @opts, $file);
+       } else {
+           print "# file '$file' skipped\n" if $verbose;
+       }
     }
 }
-